// Festlegung der Quarzfrequenz
#ifndef F_CPU                   // optional definieren
#define F_CPU 16000000UL
#endif

// Include von Header-Dateien
#include <avr/io.h>               // I/O Konfiguration (intern weitere Dateien)
#include <util/delay.h>           // Definition von Delays (Wartezeiten)
#include <stdbool.h>          // Bibliothek fuer Bit-Variable

#include "Mux_Servo.h"
#include <stdio.h>

					//Bein1,Gelenk1,Gelenk2,Gelenk3/Fu
int servo[6][4]={	{1,		12,		13,		14},
					{2,		15,		16,		17},
					{3,		0,		1,		2},
					{4,		6,		7,		8},
					{5,		9,		10,		11},
					{6,		3,		4,		5}};


//		Bein1 ====== Bein4
//				 
//		Bein2 ====== Bein5
//				 
//		Bein3 ====== Bein6

///////////////////////////////////////////////////////////////////FR TEST 
// Variable
bool fw = 0;                   // Bitspeicher fuer Taste 1
bool r = 0;                   // Bitspeicher fuer Taste 2
bool l = 0;
bool bw = 0;
// Initialisierung der Taster
void initTaster(void)
//   Bitposition im Register:
{//               __76543210
	DDRB = DDRB & 0b00111111;       // Port B auf Eingabe schalten
	DDRD = DDRD & 0b10011111;
	PORTB =       0b11000000;       // Pullup-Rs eingeschaltet
	PORTD =       0b01100000;       // Pullup-Rs eingeschaltet
	
	_delay_us(10);                  // Umschalten der Hardware-Signale abwarten
}

// Tastenwerte S1 und S2 (ohne Entprellen) einlesen
void readButtons(void)
{
	fw = !(PINB & (1 << PINB6)); // Tasten invertiert in Bitspeicher einlesen
	r = !(PINB & (1 << PINB7)); // somit gedrueckte Taste ="1"
	bw = !(PIND & (1 << PIND5)); // Tasten invertiert in Bitspeicher einlesen
	l = !(PIND & (1 << PIND6)); // somit gedrueckte Taste ="1"
}

///////////////////////////////////////////////////////////////////FR TEST 

void foot(int b, int w1, int w2, int w3)
{
	b-=1;
	if(b<=4)
	{
		servoSet(servo[b][1],w1);
		servoSet(servo[b][2],w2);
		servoSet(servo[b][3],w3);
		
		//Bewegung der Servos auf der linken Seite

	} else
	{
		servoSet(servo[b][1],w1);
		servoSet(servo[b][2],w2);
		servoSet(servo[b][3],w3);
		
		//Bewegung der Servos auf der rechten Seite
	}
}

void rest_Pos(void)
{
	foot(1, 90, 90, 135);
	foot(2, 90, 90, 135);
	foot(3, 90, 90, 135);
	foot(4, 90, 90, 135);
	foot(5, 90, 90, 135);
	foot(6, 90, 90, 135);
}

void forward(void)
{
								
}

void right(void)
{
	
}

void left(void)
{
	
}

void backward(void)
{
	
}

int main(void)
{
	servoStart();
	initTaster();               // Initialisierung der Buttons
	sei();			// Global Interrupts aktivieren
	while(1)		// Start der unendlichen Schleife
	{
		while(1)		//1 durch Bedingung des Joysticks ersetzen
		{
			readButtons();
			
			if(fw)
				forward();
				
			else if(r)
				right();

			else if(l)
				left();
			
			else if(bw)
				backward();
									
			else
				rest_Pos();
		}
	}
}

